// CGHomework_win32.cpp :  α׷   մϴ.
//

#include "stdafx.h"
#include <stdio.h>

#include <commdlg.h>
#include <tchar.h>
#include "CGHomework_win32.h"

#define MAX_LOADSTRING 100

#define	PROJ_MODE_ORTHOGONAL	1
#define PROJ_MODE_PERSPECTIVE	2

struct VECTOR
{
	float x, y, z, w;
};

struct POLYGON
{
	int v[3];			// vertex index
	BYTE r, g, b, a;
};

//  :
HINSTANCE hInst;								//  νϽԴϴ.
TCHAR szTitle[MAX_LOADSTRING];					//  ǥ ؽƮԴϴ.
TCHAR szWindowClass[MAX_LOADSTRING];			// ⺻ â Ŭ ̸Դϴ.





VECTOR*					g_pVertices;
int						g_nVertexCount;
POLYGON*				g_pPolygon;
int						g_nPolygonCount;




//  ڵ ⿡  ִ Լ  Դϴ.
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

////////////////////////////////////////////
//  ߰ Լ
void				Reset();
BOOL				LoadFile(HWND hWnd);
BOOL				LoadParametaFile(TCHAR *fileName);
BOOL				LoadMeshFile(TCHAR *fileName);
void				Render(HDC hDC);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ⿡ ڵ带 Էմϴ.
	MSG msg;
	HACCEL hAccelTable;

	//  ڿ ʱȭմϴ.
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CGHOMEWORK_WIN32, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//  α׷ ʱȭ մϴ.
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	g_pVertices = NULL;
	g_pPolygon = NULL;
	g_nPolygonCount = 0;
	g_nVertexCount = 0;

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_CGHOMEWORK_WIN32));

	// ⺻ ޽ Դϴ.
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  Լ: MyRegisterClass()
//
//  : â Ŭ մϴ.
//
//  :
//
//    Windows 95 ߰ 'RegisterClassEx' Լ 
//    ش ڵ尡 Win32 ý۰ ȣȯǵ
//    Ϸ 쿡  Լ մϴ.  Լ ȣؾ
//    ش  α׷ 
//    'ùٸ '     ֽϴ.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CGHOMEWORK_WIN32));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_CGHOMEWORK_WIN32);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   Լ: InitInstance(HINSTANCE, int)
//
//   : νϽ ڵ ϰ  â ϴ.
//
//   :
//
//         Լ  νϽ ڵ   ϰ
//         α׷ â   ǥմϴ.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // νϽ ڵ   մϴ.

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  Լ: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :  â ޽ óմϴ.
//
//  WM_COMMAND	-  α׷ ޴ óմϴ.
//  WM_PAINT	-  â ׸ϴ.
//  WM_DESTROY	-  ޽ Խϰ ȯմϴ.
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// ޴    мմϴ.
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case ID_FILE_OPEN:
			LoadFile(hWnd);
			InvalidateRect(hWnd, NULL, TRUE);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: ⿡ ׸ ڵ带 ߰մϴ.
		Render(hdc);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		Reset();
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//  ȭ  ޽ óԴϴ.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}


/////////////////////////////////////////////////////////////
//  ߰
void Reset()
{
	if(g_pVertices)
	{
		delete g_pVertices;
		g_pVertices = NULL;
	}
	if(g_pPolygon)
	{
		delete g_pPolygon;
		g_pPolygon = NULL;
	}

	g_nPolygonCount = g_nVertexCount = 0;
}

BOOL LoadFile(HWND hWnd)
{
	OPENFILENAME ofn;
	TCHAR szTotalFileName[1024];
	memset(szTotalFileName, 0, sizeof(TCHAR)*1024);
	TCHAR szAbsDirectory[1024];
	memset(szAbsDirectory, 0, sizeof(TCHAR)*1024);
	TCHAR szFileName[1024];
	memset(szFileName, 0, sizeof(TCHAR)*1024);
	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = _T("txt Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0");
	ofn.lpstrFile = szTotalFileName;
	ofn.nMaxFile = 10000;
	ofn.Flags = OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_FILEMUSTEXIST;
	ofn.lpstrDefExt = _T("txt");

	if(GetOpenFileName(&ofn))
	{
		if(!LoadMeshFile(szTotalFileName))
		{
			MessageBox(hWnd, _T("Load Mesh File Error"), NULL, 0);
			return FALSE;
		}

		MessageBox(hWnd, _T("Load Completed"), NULL, 0);
	}

	return TRUE;
}

BOOL LoadMeshFile(TCHAR *fileName)
{
	FILE *fp = _tfopen(fileName, _T("r"));
	if(!fp)
		return FALSE;

	char buffer[1024];
	char *tok = " \t\n";

	/////////////////////////////////////////////////////
	// number of vertices & number of polygons
	fgets(buffer, 1024, fp);
	char *token = strtok(buffer, tok);
	if(strcmp(token, "#numVertex") == 0)
	{
		g_nVertexCount = atoi(strtok(NULL, tok));
	}
	else if(strcmp(token, "#numPolygon") == 0)
	{
		g_nPolygonCount = atoi(strtok(NULL, tok));
	}

	fgets(buffer, 1024, fp);
	token = strtok(buffer, tok);
	if(strcmp(token, "#numVertex") == 0)
	{
		g_nVertexCount = atoi(strtok(NULL, tok));
	}
	else if(strcmp(token, "#numPolygon") == 0)
	{
		g_nPolygonCount = atoi(strtok(NULL, tok));
	}

	if(g_nPolygonCount==0 || g_nVertexCount==0)
		return FALSE;

	g_pVertices = new VECTOR[g_nVertexCount];
	g_pPolygon = new POLYGON[g_nPolygonCount];

	while(fgets(buffer, 1024, fp))
	{
		token = strtok(buffer, tok);
		int index;

		if(strcmp(token, "Vertex") == 0)
		{
			index = atoi(strtok(NULL, tok))-1;

			g_pVertices[index].x = atof(strtok(NULL, tok));
			g_pVertices[index].y = atof(strtok(NULL, tok));
			g_pVertices[index].z = atof(strtok(NULL, tok));
			g_pVertices[index].w = 1.0f;
		}
		else if(strcmp(token, "Polygon") == 0)
		{
			index = atoi(strtok(NULL, tok))-1;

			g_pPolygon[index].v[0] = atoi(strtok(NULL, tok))-1;
			g_pPolygon[index].v[1] = atoi(strtok(NULL, tok))-1;
			g_pPolygon[index].v[2] = atoi(strtok(NULL, tok))-1;

			g_pPolygon[index].r = (BYTE)atoi(strtok(NULL, tok));
			g_pPolygon[index].g = (BYTE)atoi(strtok(NULL, tok));
			g_pPolygon[index].b = (BYTE)atoi(strtok(NULL, tok));
			g_pPolygon[index].a = (BYTE)atoi(strtok(NULL, tok));
		}
	}

	fclose(fp);

	return TRUE;
}

void Render(HDC hDC)
{
	if(!g_pVertices || !g_pVertices)
		return;

	////////////////////////////////////////////////////////////////////////
	// ⿡ ׸ α׷ ۼϽø ˴ϴ.
	// eg) SetPixel(hDC, 100, 100, RGB(255, 0, 0));
}
